uniform sampler2D tex;
uniform sampler1D delta_r_div_double_k0_tex;
uniform float scalefac; // compensates for the FFT scaling properties
varying vec2 tc;
varying float k_z;
varying float f0_coord;

vec2 complex_multiply(in vec2 a, in vec2 b)
{
	return a.x * b + a.y * vec2(-b.y, b.x);
}

// computes exp(-zi)
vec2 exp_m(float z)
{
	return vec2(cos(z), -sin(z));
}

void main(void)
{
	vec4 color = texture2D(tex, tc);
	vec2 drk0 = texture1D(delta_r_div_double_k0_tex, f0_coord).xz;
	gl_FragColor.rg = scalefac * complex_multiply(exp_m(k_z * k_z * drk0.x), color.rg);
	gl_FragColor.ba = scalefac * complex_multiply(exp_m(k_z * k_z * drk0.y), color.ba);
}

