uniform sampler2D tex;

void main(void)
{
	vec4 color = texture2D(tex, gl_TexCoord[0].st);
	float luma = length(color.xy) * 10.0;

	if (luma <= 0.0) {
		gl_FragColor = vec4(0.0, 0.0, 1.0, 1.0);
	} else if (luma <= 1.0) {
		gl_FragColor = vec4(0.0, luma, 1.0, 1.0);
	} else if (luma <= 2.0) {
		gl_FragColor = vec4(0.0, 1.0, 2.0 - luma, 1.0);
	} else if (luma <= 3.0) {
		gl_FragColor = vec4(luma - 2.0, 1.0, 0.0, 1.0);
	} else if (luma <= 4.0) {
		gl_FragColor = vec4(1.0, 4.0 - luma, 0.0, 1.0);
	} else {
		gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
	}
}

