uniform sampler2D tex;
uniform sampler1D ravel_data_tex;
uniform sampler1D exp_data_tex;
varying vec2 tex_coord;

/* from [a,b,c,d] and [e,f], computes (a + bi)(e + fi) and (c + di)(e + fi) */
vec4 complex_multiply(in vec4 a, in vec2 b)
{
	return b.x * a + b.y * vec4(-a.y, a.x, -a.w, a.z);
}

void main(void)
{
	vec4 dd = texture1D(ravel_data_tex, tex_coord.x);
	vec4 ed = texture1D(exp_data_tex, tex_coord.x);

	vec2 ta = vec2(dd.x, tex_coord.y);
	vec2 tb = vec2(dd.y, tex_coord.y);

	// compute (f1 * x[x1]) and (f2 * x[x2])
	vec4 p1 = dd.z * texture2D(tex, ta);
	vec4 p2 = dd.w * texture2D(tex, tb);

	// compute (f1 * x[x1]) + i (f2 x[x2])
	vec4 f = p1 + vec4(-p2.y, p2.x, -p2.w, p2.z);

	// and postmultiply in the exponential
	gl_FragColor = complex_multiply(f, ed.xy);
}

