uniform sampler2D tex;
uniform sampler1D ravel_data_tex;
uniform sampler1D exp_data_tex;
varying vec2 tex_coord;

/* from [a,b,c,d] and [e,f], computes (a + bi)(e + fi) and (c + di)(e + fi) */
vec4 complex_multiply(in vec4 a, in vec2 b)
{
	return b.x * a + b.y * vec4(-a.y, a.x, -a.w, a.z);
}

void main(void)
{
	vec4 dd = texture1D(ravel_data_tex, tex_coord.x);
	
	// we do some extra work here, but it should be better than an extra pass
	vec4 eda = texture1D(exp_data_tex, dd.x);
	vec4 edb = texture1D(exp_data_tex, dd.y);

	vec2 ta = vec2(dd.x, tex_coord.y);
	vec2 tb = vec2(dd.y, tex_coord.y);

	// compute (f1 * x[x1]) and (f2 * x[x2])
	vec4 p1 = dd.z * complex_multiply(texture2D(tex, ta), eda.xy);
	vec4 p2 = dd.w * complex_multiply(texture2D(tex, tb), edb.xy);

	// compute (f1 * x[x1]) + i (f2 x[x2])
	gl_FragColor = p1 + vec4(-p2.y, p2.x, -p2.w, p2.z);
}

