/*
 * Simulates loss of precision in the mantissa. Strictly speaking, a GLSL compiler
 * _could_ attempt to optimize the "+x-x" part away (it isn't particularily
 * well defined), but it should not happen in practice, and it's easy to detect.
 */

uniform sampler2D tex;
uniform float scalefac;    // 2^x - 1, where x is the number of bits to lose

void main(void)
{
	vec4 color = texture2D(tex, gl_TexCoord[0].st);
	vec4 x = color * scalefac;
	gl_FragColor = color + x - x;
}

